;
; You need Nullsoft's SuperPiMP Install System (http://www.nullsoft.com/free/nsis/)
; to compile this.
;

!define AmmoName	"PowerDVD"
!define AmmoShort	"ZPowerDVD"
!define AmmoDLL		"ZPowerDVD.dll"
!define AmmoSPath	"Release"
!define AmmoPackage	"..\pdp10x.exe"


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!define ATIPath     $R8
!define ATIHWND     $R9
!define ATISATMRC   "Software\ATI Technologies\Multimedia\Remote Control"

!include "${NSISDIR}\Contrib\Modern UI\System.nsh"

!define MUI_PRODUCT "${AmmoName} Plugin"
!define MUI_VERSION ""
!define MUI_LICENSEPAGE
!define MUI_DIRECTORYPAGE
!define MUI_ABORTWARNING
!define MUI_UNINSTALLER
!define MUI_UNCONFIRMPAGE

!insertmacro MUI_LANGUAGE "English"
  
OutFile "${AmmoPackage}"
LicenseData "license.txt"

InstallDir "$PROGRAMFILES\Remote Wonder Plugins"
InstallDirRegKey HKLM "SOFTWARE\ATI Technologies\Multimedia\Remote Wonder" "PlugInsPath"

!insertmacro MUI_SYSTEM


Function LoadATIX10
   IntCmp ${ATIHWND} 0 QUIT
   Sleep 3000
   FindWindow ${ATIHWND} "AfxFrameOrView42" "ATIX10" 0 0
   IntCmp ${ATIHWND} 0 +1 QUIT
     Exec ${ATIPath}
     StrCpy ${ATIHWND} 0
QUIT:   
FunctionEnd

Function .onInit
   StrCpy ${ATIHWND} 0
   
   ;
   ; can we find ATIX10.EXE?
   ;
   ReadRegStr $R0 HKLM "SOFTWARE\ATI Technologies\Multimedia\Remote Wonder" "PlugInsPath"
   StrCpy ${ATIPath} "$R0\..\ATIX10.EXE"
   IfFileExists ${ATIPath} +1 WARN

   ;
   ; can we find the plugin registry?
   ;
   StrCpy $R4 0
AGAIN:   
   EnumRegKey $R5 HKCU "${ATISATMRC}" $R4
   StrCmp $R5 "" WARN
   StrCmp $R5 "Plug-Ins" OK
   IntOp $R4 $R4 + 1
   goto AGAIN

WARN:   
   StrCpy ${ATIPath} ""
   MessageBox MB_OK|MB_ICONINFORMATION \
     "WARNING: The version of the ATI Remote Wonder software that is installed in this computer may not be compatible with this installer. You will need to do a manual import to finish the installation (see readme).$\n$\nPlease visit http://www.polarcloud.com/ for updates."

OK:
FunctionEnd

Function .onInstFailed
   call LoadATIX10
FunctionEnd
  
Section "${AmmoName} Plugin" SecCopyUI
   ;
   ; find ATIX10, close it temporarily
   ;
   StrCmp ${ATIPath} "" WARN
   FindWindow ${ATIHWND} "AfxFrameOrView42" "ATIX10" 0 0
   IntCmp ${ATIHWND} 0 WARN
   SendMessage ${ATIHWND} ${WM_CLOSE} 0 0
   Sleep 3000
   goto FILECOPY
     
WARN:   
   MessageBox MB_OK|MB_ICONINFORMATION \
     "If you are updating an existing plugin, please turn off the ATI Remote Wonder software temporarily."

FILECOPY:   
   SetOutPath "$INSTDIR"
   File "${AmmoSPath}\${AmmoDLL}"
   File /oname=${AmmoShort}.htm readme.htm
   IfFileExists "$INSTDIR\${AmmoShort}.ini" +2
   File /oname=${AmmoShort}.ini default.ini
  
   WriteUninstaller "$INSTDIR\remove${AmmoShort}.exe"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${AmmoName}Ammo" "DisplayName" "${AmmoName} Plugin for ATI Remote Wonder (remove)"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${AmmoName}Ammo" "UninstallString" "$INSTDIR\remove${AmmoShort}.exe"

   
   ;
   ; 
   ;
   StrCmp ${ATIPath} "" QUIT
   
   ;
   ; delete existing registry entry if needed...
   ;
   StrCpy $R4 0
AGAIN:   
   EnumRegKey $R5 HKCU "${ATISATMRC}\Plug-Ins" $R4
   StrCmp $R5 "" NOMATCH
   StrLen $R3 ${AmmoName}
   IntOp $R3 $R3 + 8
   StrCpy $R6 $R5 $R3
   StrCmp $R6 "${AmmoName} Plugin " FOUND
   IntOp $R4 $R4 + 1
   goto AGAIN
FOUND:
   DeleteRegKey HKCU "${ATISATMRC}\Plug-Ins\$R5"
NOMATCH:   

   ;
   ; create a new registry entry for this plugin
   ;
   GetDLLVersionLocal "${AmmoSPath}\${AmmoDLL}" $R4 $R5
   IntOp $R5 $R4 & 0xFFFF
   IntFmt $R5 "%02u" $R5
   IntOp $R4 $R4 / 0xFFFF
   WriteRegStr HKCU "${ATISATMRC}\Plug-Ins\${AmmoName} Plugin $R4.$R5" "Filename" "$INSTDIR\${AmmoDLL}"
   WriteRegDWORD HKCU "${ATISATMRC}\Plug-Ins\${AmmoName} Plugin $R4.$R5" "Enabled" 1

   ;
   ; wake her up...
   ;
   call LoadATIX10
   
QUIT:
   ExecShell "open" "$INSTDIR\${AmmoShort}.htm"
SectionEnd

!insertmacro MUI_SECTIONS_FINISHHEADER


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Section "Uninstall"
   ;
   ; try to find ATIX10.EXE, close it if possible
   ;
;   StrCpy ${ATIHWND} 0
;   ReadRegStr $R0 HKLM "SOFTWARE\ATI Technologies\Multimedia\Remote Wonder" "PlugInsPath"
;   StrCpy ${ATIPath} "$R0\..\ATIX10.EXE"
;   IfFileExists ${ATIPath} +1 WARN
     ; !!PROBLEM!! Control Panel/Add/Remove will wait forever for the new ATIX10 process to exit
;     FindWindow ${ATIHWND} "AfxFrameOrView42" "ATIX10" 0 0
;     IntCmp ${ATIHWND} 0 WARN
;     SendMessage ${ATIHWND} ${WM_CLOSE} 0 0
;     Sleep 2000
;     goto REMOVEFILES
     
;WARN:   
   MessageBox MB_OK|MB_ICONINFORMATION \
     "NOTE: Please unload the ATI Remote Wonder software temporarily so files that are in use are removed properly."
;   StrCpy ${ATIPath} ""  

;REMOVEFILES:
   DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${AmmoName}Ammo"
   Delete "$INSTDIR\${AmmoDLL}"
   Delete "$INSTDIR\${AmmoShort}.htm"
   Delete "$INSTDIR\${AmmoShort}.ini"
   Delete "$INSTDIR\remove${AmmoShort}.exe"
;   RMDir "$INSTDIR"

   ;
   ;
   ;
   ;StrCmp ${ATIPath} "" DONE

   ;
   ; remove from ATI's registry
   ;
   StrCpy $R4 0
AGAIN:   
   EnumRegKey $R5 HKCU "${ATISATMRC}\Plug-Ins" $R4
   StrCmp $R5 "" RELOAD
   StrLen $R3 ${AmmoName}
   IntOp $R3 $R3 + 8
   StrCpy $R6 $R5 $R3
   StrCmp $R6 "${AmmoName} Plugin " FOUND
   IntOp $R4 $R4 + 1
   goto AGAIN
FOUND:
   DeleteRegKey HKCU "${ATISATMRC}\Plug-Ins\$R5"

RELOAD:
   ;
   ; !!PROBLEM!! Control Panel/Add/Remove will wait forever for the new ATIX10 process to exit
   ; reload the ATIX10.EXE
   ;
;   IntCmp ${ATIHWND} 0 DONE
;   Sleep 3000
;   FindWindow ${ATIHWND} "AfxFrameOrView42" "ATIX10" 0 0
;   IntCmp ${ATIHWND} 0 +1 DONE
;     Exec ${ATIPath}
   
;DONE:
   !insertmacro MUI_UNFINISHHEADER
SectionEnd


